(***********************************************************************)
(*                                                                     *)
(*                           xlib for Ocaml                            *)
(*                                                                     *)
(*       Fabrice Le Fessant, projet Para/SOR, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)


(* resultats :
on peut mesurer a la fois la performance du cache par les:
- le gain de vitesse
- le gain de bande passante

  sur 1000 invocations synchrones
  ===============================
unit:
./client  0.52s user 0.27s system 50% cpu 1.555 total  = 0.79

chaine longueur 1000: 
./client  0.72s user 0.30s system 48% cpu 2.104 total  = 1.02

100 pointeurs de code:  
./client  1.69s user 0.29s system 51% cpu 3.834 total  = 1.98

100 pointeurs distants: 
  - cache 512
./client  2.10s user 0.36s system 49% cpu 4.988 total  = 2.46
  - cache 32
./client  5.51s user 0.47s system 46% cpu 12.890 total = 5.98
  - cache 1
./client  6.07s user 0.42s system 46% cpu 14.102 total = 6.49

asynchrones: gain possible d  la ractivation du thread, plus lente
dans le cas synchrone que dans le cas asynchrone (pas de ractivation,
  traitement squentiel)

100 pointeurs distants:
- cache 512
./client  1.66s user 0.24s system 41% cpu 4.581 total  = 1.90
- cache 1
./client  6.55s user 0.38s system 49% cpu 14.919 total = 6.93

*)

(*
let (call: << ((unit->unit) list * <<(unit -> unit) list >>) >>) = 
  Ns.lookup "dummy_sync" vartype

let list = 
  let rec iter n list =
    if n = 0 then list else
    let def x () = reply () in
    iter (n-1) (x::list)
  in
  iter 100 []
  
let max = 1000
let n = ref 0
let def count! _ = 
  incr n;
  if !n = max then trigger ()
and trigger! () | wait () = reply ()

let _ =
  Printf.printf "started"; print_newline (); 
  for i = 0 to max do
    {| call (list,count) }
  done;
  wait ();
  exit 0
*)

let (call: unit -> unit) = 
  Ns.lookup "dummy_sync" vartype

let list = 
  let rec iter n list =
    if n = 0 then list else
    let def x () = reply () in
    iter (n-1) (x::list)
  in
  iter 100 []
  
let max = 10000
let n = ref 0
let def count! _ = 
  incr n;
  if !n = max then trigger ()
and trigger! () | wait () = reply ()

let _ =
  Printf.printf "started"; print_newline (); 
  for i = 0 to max do
    call ()
  done;
  exit 0