(***********************************************************************)
(*                                                                     *)
(*                           xlib for Ocaml                            *)
(*                                                                     *)
(*       Fabrice Le Fessant, projet Para/SOR, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

open Xtypes
open Xconst

let dpy = Xlib.openDisplay "macon:0";;
let root = Xutils.defaultRoot dpy;;

let a = X.internAtom dpy "CUT_BUFFER2" true;;
let prop = X.getProperty dpy 43 false a anyPropertyType 0 0;;
let p = X.getProperty dpy 43 false a anyPropertyType 0 2;;

let pretty_list_prop dpy win =
  let list = X.listProperties dpy win
  in
      List.map (function id ->
        let prop =Xutils.getWholeProperty dpy win id
        in
	    (X.getAtomName dpy id,X.getAtomName dpy prop.gp_type,
             prop.gp_format,prop.gp_length,prop.gp_value)
	    ) list
;;
X.changeProperty dpy root PropModeReplace
   (X.internAtom dpy "CUT_BUFFER0" false)
   (X.internAtom dpy "STRING" false) 1 "Attention"
;;

pretty_list_prop dpy root;;
print_newline ();;
(*
let fid = X.openFont dpy "fixed";;
print_string "1";print_newline();;
X.listFontsWithInfo dpy "*fixed*" 2;;
print_string "1";print_newline();;

*)
