(***********************************************************************)
(*                                                                     *)
(*                           xlib for Ocaml                            *)
(*                                                                     *)
(*       Fabrice Le Fessant, projet Para/SOR, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(*
    Le programme xprop en CAML
*)


open Xlib;;

(* connectons nous au display pour commencer *)
let dpy = Xlib.openDisplay (Sys.getenv "DISPLAY");;
let root = Xutils.defaultRoot dpy;;

(* un curseur + *)
let cursor = Xutils.createFontCursor dpy  XC.xc_crosshair;;

(* xprop dpy;; pour utiliser *)
let xprop dpy =
  List.iter 
    (function (atom,typ,n1,n2,value) ->
       print_string (atom^"("^typ^")= "^
        (
	  if typ = "STRING" then value else ""
	));
       print_newline ()

    )

    (
      Xutils.listProperties dpy (
    	let win=Xutils.selectWindow dpy cursor in
	  if win=0 then root
	  else
            Xutils.clientWindow dpy win
      ))
 ;;

xprop dpy;;


