open Obj

external alloc_dummy : int -> 'a = "alloc_dummy"
external update_dummy : 'a -> 'b -> 'c = "update_dummy"
external make_vect: int -> 'a -> 'a array = "make_vect"
external make_vect: int -> 'a -> 'a array = "make_vect"
external md5_chan: in_channel -> int -> t = "md5_chan"
external gc_stat: unit -> t = "gc_stat"
external gc_get: unit -> t = "gc_get"
external gc_set: t -> unit = "gc_set"
external gc_minor: unit -> unit = "gc_minor"
external gc_major: unit -> unit = "gc_major"
external gc_full_major: unit -> unit = "gc_full_major"
external gc_compaction: unit -> unit = "gc_compaction";;
external hash_univ_param: int -> int -> 'a -> int = "hash_univ_param" "noalloc"
external lex_engine: t -> int -> t -> int = "lex_engine"
external input_value: in_channel -> 'a = "input_value"
external obj_is_block: t -> bool = "obj_is_block"
external obj_tag: t -> int = "obj_tag"
external obj_block: int -> int -> t = "obj_block"
external obj_dup: t -> t = "obj_dup"
external obj_truncate: t -> int -> unit = "obj_truncate"
external compare: 'a -> 'a -> int = "compare" "noalloc"
external power_float: float -> float -> float = "power_float" "pow" "float"
external sqrt_float: float -> float = "sqrt_float" "sqrt" "float"
external exp_float: float -> float = "exp_float" "exp" "float"
external log_float: float -> float = "log_float" "log" "float"
external log10_float: float -> float = "log10_float" "log10" "float"
external cos_float: float -> float = "cos_float" "cos" "float"
external sin_float: float -> float = "sin_float" "sin" "float"
external tan_float: float -> float = "tan_float" "tan" "float"
external acos_float: float -> float = "acos_float" "acos" "float"
external asin_float: float -> float = "asin_float" "asin" "float"
external atan_float: float -> float = "atan_float" "atan" "float"
external atan2_float: float -> float -> float = "atan2_float" "atan2" "float"
external cosh_float: float -> float = "cosh_float" "cosh" "float"
external sinh_float: float -> float = "sinh_float" "sinh" "float"
external tanh_float: float -> float = "tanh_float" "tanh" "float"
external ceil_float: float -> float = "ceil_float" "ceil" "float"
external floor_float: float -> float = "floor_float" "floor" "float"
external fmod_float: float -> float -> float = "fmod_float" "fmod" "float"
external frexp_float: float -> float * int = "frexp_float"
external ldexp_float: float -> int -> float = "ldexp_float"
external modf_float: float -> float * float = "modf_float" "modf"
external int_of_string: string -> int = "int_of_string"
external float_of_string: string -> float = "float_of_string"
external create_string: int -> string = "create_string"
external sys_file_exists: string -> bool = "sys_file_exists"
external sys_remove: string -> unit = "sys_remove"
external sys_rename: string -> string -> unit = "sys_rename"
external sys_getenv: string -> string = "sys_getenv"
external sys_system_command: string -> int = "sys_system_command"
external sys_time: unit -> float = "sys_time"
external sys_chdir: string -> unit = "sys_chdir"
external sys_getcwd: unit -> string = "sys_getcwd"
external add_float : float -> float -> float = "add_float"

external setup : out_channel -> t = "terminfo_setup";;
external backup : int -> unit = "terminfo_backup";;
external standout : bool -> unit = "terminfo_standout";;
external resume : int -> unit = "terminfo_resume";;

external array_get_float : t -> float -> t = "array_get_float"
external array_set_float : t -> float -> t -> unit = "array_set_float"
external array_get : t -> int -> t = "array_get"
external array_set : t -> int -> t -> unit = "array_set"
external array_unsafe_get : t -> int -> t = "array_unsafe_get"
external array_unsafe_set : t -> int -> t -> unit = "array_unsafe_set"
external lessthan : t -> t -> bool = "lessthan"
external lessequal : t -> t -> bool = "lessequal"
external string_equal: string -> string -> bool = "string_equal"
external equal: string -> string -> bool = "equal"
external notequal: string -> string -> bool = "notequal"
external bitvect_test: string -> string -> bool = "bitvect_test"
external string_notequal: string -> string -> bool = "string_notequal"
external array_get_addr: 'a array -> int -> 'a = "array_get_addr"
external array_set_addr: 'a array -> int -> 'a -> unit = "array_set_addr"
external blit_string : string -> int -> string -> int -> int -> unit
                     = "blit_string" "noalloc"
external output_value : t -> 'a -> t -> unit = "output_value"
external output_value_to_string: 'a -> t -> string = "output_value_to_string"
external input_value : t -> 'a = "input_value"


let not_implemented prim_name =
  fun _ ->
  failwith ("Primitive not implemented "^prim_name)

let insert () =
Linker.export_prim "ml_string_length" String.length;
  Linker.export_prim "string_set" String.set;
  Linker.export_prim "string_get" String.get;
Linker.export_prim "make_vect" make_vect;
Linker.export_prim "make_vect" make_vect;
Linker.export_prim "md5_chan" md5_chan;
Linker.export_prim "gc_stat" gc_stat;
Linker.export_prim "gc_get" gc_get;
Linker.export_prim "gc_set" gc_set;
Linker.export_prim "gc_minor" gc_minor;
Linker.export_prim "gc_major" gc_major;
Linker.export_prim "gc_full_major" gc_full_major;
Linker.export_prim "gc_compaction" gc_compaction;
Linker.export_prim "hash_univ_param" hash_univ_param;
Linker.export_prim "lex_engine" lex_engine;
Linker.export_prim "input_value" input_value;
Linker.export_prim "obj_is_block" obj_is_block;
Linker.export_prim "obj_tag" obj_tag;
Linker.export_prim "obj_block" obj_block;
Linker.export_prim "obj_dup" obj_dup;
Linker.export_prim "obj_truncate" obj_truncate;
Linker.export_prim "compare" compare;
Linker.export_prim "power_float" power_float;
Linker.export_prim "sqrt_float" sqrt_float;
Linker.export_prim "exp_float" exp_float;
Linker.export_prim "log_float" log_float;
Linker.export_prim "log10_float" log10_float;
Linker.export_prim "cos_float" cos_float;
Linker.export_prim "sin_float" sin_float;
Linker.export_prim "tan_float" tan_float;
Linker.export_prim "acos_float" acos_float;
Linker.export_prim "asin_float" asin_float;
Linker.export_prim "atan_float" atan_float;
Linker.export_prim "atan2_float" atan2_float;
Linker.export_prim "cosh_float" cosh_float;
Linker.export_prim "sinh_float" sinh_float;
Linker.export_prim "tanh_float" tanh_float;
Linker.export_prim "ceil_float" ceil_float;
Linker.export_prim "floor_float" floor_float;
Linker.export_prim "fmod_float" fmod_float;
Linker.export_prim "frexp_float" frexp_float;
Linker.export_prim "ldexp_float" ldexp_float;
Linker.export_prim "modf_float" modf_float;
Linker.export_prim "int_of_string" int_of_string;
Linker.export_prim "float_of_string" float_of_string;
Linker.export_prim "create_string" create_string;
Linker.export_prim "sys_file_exists" sys_file_exists;
Linker.export_prim "sys_remove" sys_remove;
Linker.export_prim "sys_rename" sys_rename;
Linker.export_prim "sys_getenv" sys_getenv;
Linker.export_prim "sys_system_command" sys_system_command;
Linker.export_prim "sys_time" sys_time;
Linker.export_prim "sys_chdir" sys_chdir;
Linker.export_prim "sys_getcwd" sys_getcwd;
Linker.export_prim "string_equal" string_equal;
Linker.export_prim "equal" equal;
Linker.export_prim "notequal" notequal;
Linker.export_prim "lessthan" lessthan;
Linker.export_prim "lessequal" lessequal;
Linker.export_prim "array_set" array_set;
Linker.export_prim "array_get" array_get;
Linker.export_prim "array_set_float" array_set_float;
Linker.export_prim "array_get_float" array_get_float;
Linker.export_prim "add_float" add_float;
Linker.export_prim "array_unsafe_set" array_unsafe_set;
Linker.export_prim "array_unsafe_get" array_unsafe_get;
Linker.export_prim "blit_string" blit_string;

Linker.export_prim "bitvect_test" bitvect_test;
Linker.export_prim "string_notequal" string_notequal;
Linker.export_prim "array_get_addr" array_get_addr;
Linker.export_prim "array_set_addr" array_set_addr;
Linker.export_prim "terminfo_setup" setup ;
Linker.export_prim "terminfo_backup" backup ;
Linker.export_prim "terminfo_standout" standout ;
Linker.export_prim "terminfo_resume" resume ;

Linker.export_prim "get_global_data" (not_implemented "get_global_data");
Linker.export_prim "realloc_global" (not_implemented "realloc_global" );
Linker.export_prim "static_alloc" (not_implemented "static_alloc");
Linker.export_prim "static_free" (not_implemented "static_free");
Linker.export_prim "static_resize" (not_implemented "static_resize" );
Linker.export_prim "reify_bytecode" (not_implemented "reify_bytecode");
Linker.export_prim "available_primitives" (not_implemented "available_primitives" );
Linker.export_prim "invoke_traced_function" (not_implemented "invoke_traced_function");


Linker.export_prim "output_value_to_string" output_value_to_string;
Linker.export_prim "output_value" output_value;
Linker.export_prim "input_value" input_value;

Linker.export_prim "alloc_dummy" alloc_dummy;
Linker.export_prim "update_dummy" update_dummy;
