/***********************************************************************/
/*                                                                     */
/*                           NPRremote                                 */
/*                                                                     */
/*          Francois Rouaix, projet Cristal, INRIA Rocquencourt        */
/*                                                                     */
/*  Copyright 1996 Institut National de Recherche en Informatique et   */
/*  Automatique.  Distributed only by permission.                      */
/*                                                                     */
/***********************************************************************/

/*
 * Simple Netscape 3.0 Plugin for remote-server.
 *
 *  Basic IO primitives for communication between Navigator and Server
 */

#include <stdio.h>
#include "npapi.h"

/* Read an integer on a file descriptor.
  Assumes positive integers only (-1 used for EOF or error)
 */
int readint(int fd) {
  static char buf[32];
  int pos = 0;
  while (1) {
    if (1 == read(fd, &buf[pos], 1)) {
      if (isspace(buf[pos])) {	/* found terminator */
	buf[pos]=0;
	return(atoi(buf));
      };
      pos++;
    }
    else return -1;
  }
}

/* Read a string, BCPL style (integer giving length, followed by string) */
char *readstring(int fd) {
  char *buf;
  int len,pos;
  
  if (-1 == (len = readint(fd))) return NULL;
  if (NULL == (buf = NPN_MemAlloc(len+1))) return NULL;
  if (read(fd, buf, len) == len) {
    buf[len]=0;
    return buf;
  }
  else {
    NPN_MemFree(buf);
    return NULL;
  }
}

void readack(int fd) {
  static char buf[32];
  read(fd,&buf,1);
}


void writeint(int fd, int n) {
  static char buffer[32];
  int len;
  len = sprintf(buffer, "%d ", n);
  write(fd, buffer, len);
}

void writestring(int fd, const char *buf, int len) {
  writeint(fd, len);
  write(fd, buf, len);
}


void writeack(int fd) {
  write(fd, " ", 1);
}
