
type ('a,'b,'c) triple = Triple of 'a * 'b * 'c

let new_cons (h,t) =
  let def  head   () =  reply h to head
    or   tail   () =  reply t to tail
    or   null   () =  reply false to null 
  in  (Triple (null,head,tail))
  
let new_nil () =     
  let def  head   () = reply (failwith "head of nil")
    or   tail   () = reply (failwith "tail of nil")
    or   null   () = reply true to null
  in  (Triple (null,head,tail))
  
let def safe(x, y, list) = 
    reply (
      match list with Triple (n,head,tail) ->
          if n() then  
          true
        else
        let v = head() in 
        if x=v || x=v+y || x=v-y then 
          false
        else
          safe(x, y+1,tail()))
      to safe
    
let def trypos(q,b,l) = 
    reply
    if q = 0  then 
      l
    else
    let v = safe(q,1,b) in
    if v then 
      trypos(q-1,b,new_cons(new_cons(q,b),l))
    else
      trypos(q-1,b,l)
      to trypos
      
let def foldll(l,y,v) = 
    reply
    (match l with Triple (n,h,t) ->
        if n() then
          v
        else
      foldll(t(),y,trypos(y,h(),v)))
          to foldll
          
let def gen(x,y) = 
    reply
    if x=0 then 
      new_cons(new_nil(),new_nil())
    else
      foldll(gen(x-1,y),y,new_nil())
      to gen
      
let def list_size(l) = 
    reply
      (match l with Triple (n,head,t) ->
          if n() then
            0
          else
            1 + list_size(t()))
    to list_size
    
let def queens(size) = 
    reply
      (let x = gen(size,size) in 
      let y = list_size(x) in       
      y
    )
    
;;
begin
  print_string("queens(10)=");
  print_int (queens(10));
  print_newline ()
end

