open Obj

external c_import_module : string -> t = "c_import_module"

(* On ne veux pas utiliser directement le module, car les pointeurs
   vers les fonctions natives qui y sont presentes ne peuvent pas
   migrer.  On les remplace donc par des closures bytecode contenant
   le nom du module et la position de la clossure native dedans, closure
   qui pourra etre envoye a distance.
   *)

let import_module module_name =
  let m = c_import_module ("module+"^module_name)
  in
  let len = size m in
  let block = new_block Tag.interface len in
    for i = 0 to len - 1 do
      let x = field m i in
      set_field block i (
      if Obj.is_block x &&  Obj.tag x == Tag.closure_asm then
        repr (function x -> 
          let m = c_import_module ("module+"^module_name)
          in
          (magic (field m i)) x)
      else 
        x)
    done;
    block

